Index: src/org/mifos/application/accounts/loan/business/LoanBO.java
===================================================================
--- src/org/mifos/application/accounts/loan/business/LoanBO.java	(revision 12247)
+++ src/org/mifos/application/accounts/loan/business/LoanBO.java	(working copy)
@@ -206,20 +206,29 @@
 	private Short recurMonth;
 	
 
-	protected LoanBO() {
-		super();
-		this.loanOffering = null;
-		this.loanSummary = null;
+	protected LoanBO() {		
+		this(null, null, null, null, null);
 		this.loanPrdPersistence = null;
-		this.performanceHistory = null;
 		this.loanActivityDetails = new HashSet<LoanActivityEntity>();
         this.redone = false;
- 		this.maxMinLoanAmount = null;
-		this.maxMinNoOfInstall = null;
     	parentAccount=null;
     	loanAccountDetails=new HashSet<LoanBO>();
 	}
+	
+	public LoanBO(LoanOfferingBO loanOffering){
+		this(loanOffering, null, null, null, null);
+	}
 
+	private LoanBO(LoanOfferingBO loanOffering, LoanSummaryEntity loanSummary, MaxMinLoanAmount maxMinLoanAmount, 
+			MaxMinNoOfInstall maxMinNoOfInstall, LoanPerformanceHistoryEntity performanceHistory) {
+		this.loanOffering = loanOffering;
+		this.loanSummary = loanSummary;
+		this.maxMinLoanAmount = maxMinLoanAmount;
+		this.maxMinNoOfInstall = maxMinNoOfInstall;
+		this.performanceHistory = performanceHistory;		
+	}
+	
+
 	public static LoanBO redoLoan(UserContext userContext,
 			LoanOfferingBO loanOffering, CustomerBO customer,
 			AccountState accountState, Money loanAmount,
@@ -3406,7 +3415,8 @@
 	public RankType getWeekRank() {
 		return monthRank!=null ? RankType.getRankType(monthRank.getId()) : null;
 	}
-	
 
-	
+	public boolean isOfProductOffering(LoanOfferingBO loanOfferingBO) {
+		return this.loanOffering.equals(loanOfferingBO);
+	}
 }
Index: src/org/mifos/application/accounts/savings/business/SavingsBO.java
===================================================================
--- src/org/mifos/application/accounts/savings/business/SavingsBO.java	(revision 12247)
+++ src/org/mifos/application/accounts/savings/business/SavingsBO.java	(working copy)
@@ -137,6 +137,11 @@
 		savingsActivityDetails = new HashSet<SavingsActivityEntity>();
 	}
 
+	public SavingsBO(SavingsOfferingBO savingsOffering) {
+		this.savingsOffering = savingsOffering;
+		
+	}
+
 	public Money getRecommendedAmount() {
 		return recommendedAmount;
 	}
@@ -2144,4 +2149,8 @@
 		}else
 			return trxnDate.equals(DateUtils.getCurrentDateWithoutTimeStamp());
 	}
+
+	public boolean isOfProductOffering(SavingsOfferingBO productOffering) {
+		return savingsOffering.equals(productOffering);
+	}
 }
Index: src/org/mifos/application/collectionsheet/business/CollSheetLnDetailsEntity.java
===================================================================
--- src/org/mifos/application/collectionsheet/business/CollSheetLnDetailsEntity.java	(revision 12247)
+++ src/org/mifos/application/collectionsheet/business/CollSheetLnDetailsEntity.java	(working copy)
@@ -37,6 +37,8 @@
  */
 package org.mifos.application.collectionsheet.business;
 
+import java.io.Serializable;
+
 import org.mifos.application.accounts.business.AccountActionDateEntity;
 import org.mifos.application.accounts.loan.business.LoanBO;
 import org.mifos.application.accounts.loan.business.LoanScheduleEntity;
@@ -49,6 +51,7 @@
 import org.mifos.framework.exceptions.ApplicationException;
 import org.mifos.framework.exceptions.SystemException;
 import org.mifos.framework.util.helpers.Money;
+import org.mifos.framework.util.helpers.MoneyUtils;
 
 public class CollSheetLnDetailsEntity extends PersistentObject {
 
@@ -290,7 +293,8 @@
 	public void addAccountDetails(AccountActionDateEntity accountActionDate)
 			throws SystemException, ApplicationException {
 		LoanScheduleEntity loanSchedule = (LoanScheduleEntity) accountActionDate;
-		LoanBO loan = new LoanPersistence().getAccount(loanSchedule.getAccount().getAccountId());
+		LoanBO loan = new LoanPersistence().getAccount(loanSchedule
+				.getAccount().getAccountId());
 		this.accountId = loanSchedule.getAccount().getAccountId();
 		this.currentInstallmentNo = loanSchedule.getInstallmentId();
 		MifosLogManager.getLogger(LoggerConstants.COLLECTIONSHEETLOGGER).debug(
@@ -333,7 +337,8 @@
 				&& null != collectionSheetLoanDetailsObj.getLoanDetailsId()) {
 			return loanDetailsId.equals(collectionSheetLoanDetailsObj
 					.getLoanDetailsId());
-		} else if (null != this.collectionSheetCustomer
+		}
+		else if (null != this.collectionSheetCustomer
 				&& null != collectionSheetLoanDetailsObj
 						.getCollectionSheetCustomer()) {
 			return this.accountId.equals(collectionSheetLoanDetailsObj
@@ -341,7 +346,8 @@
 					&& this.collectionSheetCustomer
 							.equals(collectionSheetLoanDetailsObj
 									.getCollectionSheetCustomer());
-		} else {
+		}
+		else {
 			return super.equals(collectionSheetLoanDetailsObj);
 		}
 
@@ -356,15 +362,17 @@
 	 * This sets accountId,amntToBeDisbursed and sets installment id to null
 	 * because installments haven't begun yet.
 	 */
-    public void addDisbursalDetails(LoanBO loan) {
-		MifosLogManager.getLogger(LoggerConstants.COLLECTIONSHEETLOGGER).debug("inside add disbursaldetails");
-		
+	public void addDisbursalDetails(LoanBO loan) {
+		MifosLogManager.getLogger(LoggerConstants.COLLECTIONSHEETLOGGER).debug(
+				"inside add disbursaldetails");
+
 		this.accountId = loan.getAccountId();
 		// TODO check in case of interest deducted at disbursement this should
 		// show the loan amount to be disbursed.
 		this.amntToBeDisbursed = loan.getLoanAmount();
-		if(loan.isInterestDeductedAtDisbursement()){
-			LoanScheduleEntity loanSchedule = (LoanScheduleEntity)loan.getAccountActionDate(CollectionSheetConstants.FIRST_INSTALLMENT);
+		if (loan.isInterestDeductedAtDisbursement()) {
+			LoanScheduleEntity loanSchedule = (LoanScheduleEntity) loan
+					.getAccountActionDate(CollectionSheetConstants.FIRST_INSTALLMENT);
 			this.interestDue = loanSchedule.getInterestDue();
 			this.feesDue = loanSchedule.getTotalFeeDue();
 		}
@@ -373,4 +381,12 @@
 		this.originalLoanAmnt = loan.getLoanAmount();
 		this.totalPrincipalDue = this.originalLoanAmnt;
 	}
+
+	public Money getTotalFees() {
+		return MoneyUtils.add(getFeesDue(), getFeesOverDue());
+	}
+
+	public Money getTotalPenalty() {
+		return MoneyUtils.add(getPenaltyDue(), getPenaltyOverDue());
+	}
 }
Index: src/org/mifos/application/collectionsheet/business/CollSheetCustBO.java
===================================================================
--- src/org/mifos/application/collectionsheet/business/CollSheetCustBO.java	(revision 12247)
+++ src/org/mifos/application/collectionsheet/business/CollSheetCustBO.java	(working copy)
@@ -96,6 +96,24 @@
 	
 	private Short loanOfficerId ;
 	
+	public CollSheetCustBO(Integer custId, String custDisplayName,
+			Short custLevel, Short custOfficeId, String searchId, Short loanOfficerId) {
+		super();
+		this.custId = custId;
+		this.custDisplayName = custDisplayName;
+		this.custLevel = custLevel;
+		this.custOfficeId = custOfficeId;
+		this.searchId = searchId;
+		this.loanOfficerId = loanOfficerId;
+		collectionSheetLoanDetails = new HashSet<CollSheetLnDetailsEntity>();
+		collSheetSavingsDetails = new HashSet<CollSheetSavingsDetailsEntity>();
+	}
+
+	public CollSheetCustBO() {
+		this(null, null, null, null, null, null);
+	}
+
+
 	public Long getCollSheetCustId() {
 		return collSheetCustId;
 	}
Index: src/org/mifos/application/collectionsheet/business/CollectionSheetBO.java
===================================================================
--- src/org/mifos/application/collectionsheet/business/CollectionSheetBO.java	(revision 12247)
+++ src/org/mifos/application/collectionsheet/business/CollectionSheetBO.java	(working copy)
@@ -71,6 +71,17 @@
 
 	private Set<CollSheetCustBO> collectionSheetCustomers;
 
+	public CollectionSheetBO(Date collSheetDate, Date runDate, Set<CollSheetCustBO> collectionSheetCustomers, Short statusFlag) {
+		super();
+		this.collSheetDate = collSheetDate;
+		this.runDate = runDate;
+		this.collectionSheetCustomers = collectionSheetCustomers;
+		this.statusFlag = statusFlag;
+		for(CollSheetCustBO customer: collectionSheetCustomers) {
+			customer.setCollectionSheet(this);
+		}
+	}
+
 	public Date getCollSheetDate() {
 		return collSheetDate;
 	}
Index: src/org/mifos/application/NamedQueryConstants.java
===================================================================
--- src/org/mifos/application/NamedQueryConstants.java	(revision 12247)
+++ src/org/mifos/application/NamedQueryConstants.java	(working copy)
@@ -340,6 +340,17 @@
 
 	public String MASTERDATA_ACTIVE_BRANCHES = "masterdata.activeBranches";
 	public String GET_FIELD_TYPE = "getFieldType";
+	
+	public static final String COLLECTION_SHEET_FOR_SPECIFIED_CUSTOMER = "collectionSheet.getCollectionSheetForCenterWithSpecifiedMeetingDate";
+	public static final String COLLECTION_SHEETS_FOR_MEETING_DATE = "collectionSheet.getCollectionSheetForMeetingDate";
+	public static final String COLLECTION_SHEET_CUSTOMERS_ON_MEETING_DATE_FOR_LOAN_OFFICER = "CollectionSheetCustomer.collectionSheetForSpecifiedMeetingDateAndLoanOfficer";
+	public static final String COLLECTION_SHEET_CUSTOMERS_ON_MEETING_DATE = "CollectionSheetCustomer.collectionSheetForSpecifiedMeetingDate";
+	public static final String COLLECTION_SHEETS_OF_CHILDREN_ON_MEETING_DATE = "CollectionSheetCustomer.collectionSheetOfCustomersUnderAParentForSpecifiedMeetingDate";
+	public static final String GET_ACTIVE_BRANCHES_AS_SELECTION_ITEM = "SelectionItem.get_active_offices";
+	public static final String GET_ACTIVE_LOAN_OFFICERS_UNDER_OFFICE_AS_SELECTION_ITEM = "SelectionItem.get_active_loanofficers_under_office";
+	public static final String GET_ACTIVE_CUSTOMERS_UNDER_LOAN_OFFICER_AS_SELECTION_ITEM = "SelectionItem.get_active_customers_under_loanofficers";
+	public static final String GET_MEETING_DATES_AS_SELECTION_ITEM = "DateSelectionItem.get_meeting_dates";
+	
 	/**M2 queries*/
 	/**Personnel Queries*/
 	public String MASTERDATA_ACTIVE_LOANOFFICERS_INBRANCH = "masterdata.activeloanofficers";
@@ -686,4 +697,4 @@
 	public String GET_TOP_LEVEL_ACCOUNTS = "COABO.getTopLevelAccounts";
 	public String GET_ACCOUNT_ID_FOR_GL_CODE = "COABO.getAccountIdForGLCode";
 	public String GET_ALL_COA = "COABO.getAllCoa";
-}
\ No newline at end of file
+}
Index: src/org/mifos/application/productdefinition/business/SavingsOfferingBO.java
===================================================================
--- src/org/mifos/application/productdefinition/business/SavingsOfferingBO.java	(revision 12247)
+++ src/org/mifos/application/productdefinition/business/SavingsOfferingBO.java	(working copy)
@@ -83,6 +83,10 @@
 	private MifosLogger prdLogger = MifosLogManager
 			.getLogger(LoggerConstants.PRDDEFINITIONLOGGER);
 
+	public SavingsOfferingBO(){
+		this(null, null, null, new HashSet<PrdOfferingMeetingEntity>());
+	}
+	
 	public SavingsOfferingBO(UserContext userContext, String prdOfferingName,
 			String prdOfferingShortName, ProductCategoryBO prdCategory,
 			PrdApplicableMasterEntity prdApplicableMaster, Date startDate,
@@ -137,11 +141,17 @@
 				+ getGlobalPrdOfferingNum());
 	}
 
-	protected SavingsOfferingBO() {
-		depositGLCode = null;
-		interestGLCode = null;
-		savingsOfferingMeetings = new HashSet<PrdOfferingMeetingEntity>();
+	protected SavingsOfferingBO(Short prdOfferingId, GLCodeEntity depositGLCode, 
+			GLCodeEntity interestGLCode, HashSet<PrdOfferingMeetingEntity> savingsOfferingMeetings) {
+		super(prdOfferingId);
+		this.depositGLCode = depositGLCode;
+		this.interestGLCode = interestGLCode;
+		this.savingsOfferingMeetings = savingsOfferingMeetings;
 	}
+	
+	public SavingsOfferingBO(Short prdOfferingId){
+		this(prdOfferingId, null, null, new HashSet<PrdOfferingMeetingEntity>());
+	}
 
 	private Set<PrdOfferingMeetingEntity> getSavingsOfferingMeetings() {
 		return savingsOfferingMeetings;
Index: src/org/mifos/application/productdefinition/business/PrdOfferingBO.java
===================================================================
--- src/org/mifos/application/productdefinition/business/PrdOfferingBO.java	(revision 12247)
+++ src/org/mifos/application/productdefinition/business/PrdOfferingBO.java	(working copy)
@@ -103,14 +103,19 @@
 			.getLogger(LoggerConstants.PRDDEFINITIONLOGGER);
 
 	protected PrdOfferingBO() {
-		prdOfferingId = null;
-		globalPrdOfferingNum = null;
-		prdType = null;
-		office = null;
+		this(null, null, null, null);
 		prdApplicableMaster = null;
 		collectionProductMix=null;
 		prdOfferingNotAllowedId=null;
 	}
+	
+	protected PrdOfferingBO(Short prdOfferingId, String globalPrdOfferingNum, ProductTypeEntity prdType,
+			OfficeBO office){
+		this.prdOfferingId = prdOfferingId;
+		this.globalPrdOfferingNum = globalPrdOfferingNum;
+		this.prdType = prdType;
+		this.office = office;		
+	}
 
 	protected PrdOfferingBO(UserContext userContext, String prdOfferingName,
 			String prdOfferingShortName, ProductCategoryBO prdCategory,
@@ -154,6 +159,10 @@
 		prdLogger.debug("creating product offering done");
 	}
 
+	public PrdOfferingBO(Short prdOfferingId) {
+		this(prdOfferingId, null, null, null);		
+	}
+
 	public Short getPrdOfferingId() {
 		return prdOfferingId;
 	}
@@ -458,4 +467,30 @@
 		this.setPrdMixFlag(YesNoFlag.YES.getValue());
 		new PrdOfferingPersistence().createOrUpdate(this);
 	}
+
+	@Override
+	public int hashCode() {
+		final int PRIME = 31;
+		int result = 1;
+		result = PRIME * result + ((prdOfferingId == null) ? 0 : prdOfferingId.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		final PrdOfferingBO other = (PrdOfferingBO) obj;
+		if (prdOfferingId == null) {
+			if (other.prdOfferingId != null)
+				return false;
+		}
+		else if (!prdOfferingId.equals(other.prdOfferingId))
+			return false;
+		return true;
+	}
 }
Index: src/org/mifos/application/productdefinition/business/LoanOfferingBO.java
===================================================================
--- src/org/mifos/application/productdefinition/business/LoanOfferingBO.java	(revision 12247)
+++ src/org/mifos/application/productdefinition/business/LoanOfferingBO.java	(working copy)
@@ -55,6 +55,7 @@
 import org.mifos.application.meeting.exceptions.MeetingException;
 import org.mifos.application.meeting.util.helpers.MeetingType;
 import org.mifos.application.meeting.util.helpers.RecurrenceType;
+import org.mifos.application.office.business.OfficeBO;
 import org.mifos.application.productdefinition.exceptions.ProductDefinitionException;
 import org.mifos.application.productdefinition.persistence.LoanPrdPersistence;
 import org.mifos.application.productdefinition.struts.actionforms.LoanPrdActionForm;
@@ -358,18 +359,40 @@
 	}
 
 	protected LoanOfferingBO() {
-		principalGLcode = null;
-		interestGLcode = null;
-		loanOfferingFunds = new HashSet<LoanOfferingFundEntity>();
-		loanOfferingFees = new HashSet<LoanOfferingFeesEntity>();
-		loanAmountFromLastLoan = new HashSet<LoanAmountFromLastLoanAmountBO>();
-		loanAmountFromLoanCycle = new HashSet<LoanAmountFromLoanCycleBO>();
-		noOfInstallFromLastLoan = new HashSet<NoOfInstallFromLastLoanAmountBO>();
-		noOfInstallFromLoanCycle = new HashSet<NoOfInstallFromLoanCycleBO>();
-		loanAmountSameForAllLoan = new HashSet<LoanAmountSameForAllLoanBO>();
-		noOfInstallSameForAllLoan = new HashSet<NoOfInstallSameForAllLoanBO>();
+		this(null, null, null, null, null, null, new HashSet<LoanOfferingFundEntity>(), 
+				new HashSet<LoanOfferingFeesEntity>(), new HashSet<LoanAmountFromLastLoanAmountBO>(), 
+				new HashSet<LoanAmountFromLoanCycleBO>(), new HashSet<NoOfInstallFromLastLoanAmountBO>(), 
+				new HashSet<NoOfInstallFromLoanCycleBO>(), new HashSet<LoanAmountSameForAllLoanBO>(), 
+				new HashSet<NoOfInstallSameForAllLoanBO>());
+	}
 
+	private LoanOfferingBO(Short prdOfferingId, String globalPrdOfferingNum, 
+			ProductTypeEntity prdType, OfficeBO office,
+			GLCodeEntity principalGLcode, 
+			GLCodeEntity interestGLcode, 
+			Set<LoanOfferingFundEntity> loanOfferingFunds, 
+			Set<LoanOfferingFeesEntity> loanOfferingFees, 
+			Set<LoanAmountFromLastLoanAmountBO> loanAmountFromLastLoan, 
+			Set<LoanAmountFromLoanCycleBO> loanAmountFromLoanCycle, Set<NoOfInstallFromLastLoanAmountBO> noOfInstallFromLastLoan, Set<NoOfInstallFromLoanCycleBO> noOfInstallFromLoanCycle, Set<LoanAmountSameForAllLoanBO> loanAmountSameForAllLoan, Set<NoOfInstallSameForAllLoanBO> noOfInstallSameForAllLoan) {
+		super(prdOfferingId, globalPrdOfferingNum, prdType, office);
+		this.principalGLcode = principalGLcode;
+		this.interestGLcode = interestGLcode;
+		this.loanOfferingFunds = loanOfferingFunds;
+		this.loanOfferingFees = loanOfferingFees;
+		this.loanAmountFromLastLoan = loanAmountFromLastLoan;
+		this.loanAmountFromLoanCycle = loanAmountFromLoanCycle;
+		this.noOfInstallFromLastLoan = noOfInstallFromLastLoan;
+		this.noOfInstallFromLoanCycle = noOfInstallFromLoanCycle;
+		this.loanAmountSameForAllLoan = loanAmountSameForAllLoan;
+		this.noOfInstallSameForAllLoan = noOfInstallSameForAllLoan;
+	}
 
+	public LoanOfferingBO(Short prdOfferingId) {
+		this(prdOfferingId, null, null, null, null, null, new HashSet<LoanOfferingFundEntity>(), 
+				new HashSet<LoanOfferingFeesEntity>(), new HashSet<LoanAmountFromLastLoanAmountBO>(), 
+				new HashSet<LoanAmountFromLoanCycleBO>(), new HashSet<NoOfInstallFromLastLoanAmountBO>(), 
+				new HashSet<NoOfInstallFromLoanCycleBO>(), new HashSet<LoanAmountSameForAllLoanBO>(), 
+				new HashSet<NoOfInstallSameForAllLoanBO>());
 	}
 
 	public GracePeriodTypeEntity getGracePeriodType() {
Index: src/org/mifos/application/office/business/OfficeBO.java
===================================================================
--- src/org/mifos/application/office/business/OfficeBO.java	(revision 12247)
+++ src/org/mifos/application/office/business/OfficeBO.java	(working copy)
@@ -60,10 +60,7 @@
 	private Set<OfficeBO> children;
 
 	public OfficeBO() {
-		super();
-		maxChildCount = null;
-		officeId = null;
-		operationMode = null;
+		this(null, null, null, null);
 		status = new OfficeStatusEntity(OfficeStatus.ACTIVE);
 		address = new OfficeAddressEntity();
 	}
@@ -145,6 +142,14 @@
 		verifyFields(officeName, shortName, level, operationMode, parentOffice);
 	}
 
+	public OfficeBO(Short officeId, String officeName, Integer maxChildCount, Short operationMode) {
+		super();
+		this.officeId = officeId;
+		this.officeName = officeName;
+		this.maxChildCount = maxChildCount;
+		this.operationMode = operationMode;
+	}
+
 	@Override
 	public void setCreatedDate(Date createdDate) {
 		this.createdDate = createdDate;
Index: src/org/mifos/application/reports/exceptions/ReportServiceInitializationException.java
===================================================================
--- src/org/mifos/application/reports/exceptions/ReportServiceInitializationException.java	(revision 0)
+++ src/org/mifos/application/reports/exceptions/ReportServiceInitializationException.java	(revision 0)
@@ -0,0 +1,9 @@
+package org.mifos.application.reports.exceptions;
+
+public class ReportServiceInitializationException extends RuntimeException {
+
+	public ReportServiceInitializationException(String message, Throwable cause) {
+		super(message, cause);
+	}
+
+}
Index: src/org/mifos/application/reports/struts/action/BirtReportValidationFilter.java
===================================================================
--- src/org/mifos/application/reports/struts/action/BirtReportValidationFilter.java	(revision 12247)
+++ src/org/mifos/application/reports/struts/action/BirtReportValidationFilter.java	(working copy)
@@ -12,34 +12,42 @@
 import javax.servlet.http.HttpServletResponse;
 
 public class BirtReportValidationFilter implements Filter {
-	
+
 	private String errorMessage;
+	private FilterConfig filterConfig;
 
 	public void doFilter(ServletRequest request, ServletResponse response,
 			FilterChain chain) throws IOException, ServletException {
 		errorMessage = "";
 		String currentReport = request.getParameter("__report");
-		
+
 		HashMap<String, String> errorMessages = new HashMap<String, String>();
 		errorMessages.put("branchId", "Please select a Branch Office.");
-		errorMessages.put("loanOfficerId",  "Please select a Loan Officer.");
+		errorMessages.put("loanOfficerId", "Please select a Loan Officer.");
 		errorMessages.put("loanProductId", "Please select a Loan Procuct.");
-		
-		reportFilter(currentReport, "report/ActiveLoansByLoanOfficer.rptdesign", errorMessages, request);
-		reportFilter(currentReport, "report/DetailedAgingPortfolioAtRisk.rptdesign", errorMessages, request);
-		
-		if(errorMessage.length() == 0) {
+
+		reportFilter(currentReport,
+				"report/ActiveLoansByLoanOfficer.rptdesign", errorMessages,
+				request);
+		reportFilter(currentReport,
+				"report/DetailedAgingPortfolioAtRisk.rptdesign", errorMessages,
+				request);
+
+		if (errorMessage.length() == 0) {
 			chain.doFilter(request, response);
 		}
 		else {
 			showError(request, response);
+
 		}
 	}
 
-	private void reportFilter(String currentReport, String expectedReport, HashMap<String, String> parameters, ServletRequest request) {
-		if(currentReport.equals(expectedReport)) {
-			for(String parameter : parameters.keySet()){
-				if(request.getParameter(parameter) != null &&request.getParameter(parameter).equals("-2")) {
+	private void reportFilter(String currentReport, String expectedReport,
+			HashMap<String, String> parameters, ServletRequest request) {
+		if (currentReport.equals(expectedReport)) {
+			for (String parameter : parameters.keySet()) {
+				if (request.getParameter(parameter) != null
+						&& request.getParameter(parameter).equals("-2")) {
 					addErrorMessage(parameters.get(parameter));
 				}
 			}
@@ -52,17 +60,18 @@
 
 	private void showError(ServletRequest request, ServletResponse response)
 			throws IOException, ServletException {
-		HttpServletResponse httpServletResponse = (HttpServletResponse) response;
-		httpServletResponse
-				.sendRedirect("/mifos/run?__report="
-						+ request.getParameter("__report") + "&reportName="
-						+ request.getParameter("reportName") + "&userId="
-						+ request.getParameter("userId") + "&__format="
-						+ request.getParameter("__format") + "&message="
-						+ errorMessage);
+		
+		HttpServletResponse httpServletResponse = (HttpServletResponse) response;		
+		httpServletResponse.sendRedirect("run?__report="
+				+ request.getParameter("__report") + "&reportName="
+				+ request.getParameter("reportName") + "&userId="
+				+ request.getParameter("userId") + "&__format="
+				+ request.getParameter("__format") + "&mifosErrorMessage="
+				+ errorMessage);
 	}
 
-	public void init(FilterConfig arg0) throws ServletException {
+	public void init(FilterConfig filterConfig) throws ServletException {
+		this.filterConfig = filterConfig;
 	}
 
 	public void destroy() {
Index: src/org/mifos/application/reports/persistence/DateSelectionItemPersistence.java
===================================================================
--- src/org/mifos/application/reports/persistence/DateSelectionItemPersistence.java	(revision 0)
+++ src/org/mifos/application/reports/persistence/DateSelectionItemPersistence.java	(revision 0)
@@ -0,0 +1,29 @@
+package org.mifos.application.reports.persistence;
+
+import java.util.Date;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.mifos.application.NamedQueryConstants;
+import org.mifos.application.collectionsheet.util.helpers.CollectionSheetConstants;
+import org.mifos.application.reports.ui.DateSelectionItem;
+import org.mifos.framework.exceptions.PersistenceException;
+import org.mifos.framework.persistence.Persistence;
+
+public class DateSelectionItemPersistence extends Persistence {
+	public List<DateSelectionItem> getMeetingDates(Short branchId,
+			Short loanOfficerId, Integer customerId, Short customerLevel, Date from)
+			throws PersistenceException {
+		Map<String, Object> queryParameters = new HashMap<String, Object>();
+		queryParameters.put("COLL_SHEET_RUN_STATUS", CollectionSheetConstants.COLLECTION_SHEET_GENERATION_SUCCESSFUL);
+		queryParameters.put("customerId", customerId);
+		queryParameters.put("CUSTOMER_LEVEL", customerLevel);
+		queryParameters.put("branchId", branchId);
+		queryParameters.put("loanOfficerId", loanOfficerId);
+		queryParameters.put("fromDate", from);
+		return executeNamedQuery(
+				NamedQueryConstants.GET_MEETING_DATES_AS_SELECTION_ITEM,
+				queryParameters);
+	}
+}
Index: src/org/mifos/application/reports/persistence/SelectionItemPersistence.java
===================================================================
--- src/org/mifos/application/reports/persistence/SelectionItemPersistence.java	(revision 0)
+++ src/org/mifos/application/reports/persistence/SelectionItemPersistence.java	(revision 0)
@@ -0,0 +1,75 @@
+package org.mifos.application.reports.persistence;
+
+import static org.mifos.application.NamedQueryConstants.GET_ACTIVE_BRANCHES_AS_SELECTION_ITEM;
+import static org.mifos.application.NamedQueryConstants.GET_ACTIVE_CUSTOMERS_UNDER_LOAN_OFFICER_AS_SELECTION_ITEM;
+import static org.mifos.application.NamedQueryConstants.GET_ACTIVE_LOAN_OFFICERS_UNDER_OFFICE_AS_SELECTION_ITEM;
+
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.mifos.application.NamedQueryConstants;
+import org.mifos.application.customer.util.helpers.CustomerLevel;
+import org.mifos.application.customer.util.helpers.CustomerStatus;
+import org.mifos.application.office.util.helpers.OfficeLevel;
+import org.mifos.application.office.util.helpers.OfficeStatus;
+import org.mifos.application.personnel.util.helpers.PersonnelLevel;
+import org.mifos.application.personnel.util.helpers.PersonnelStatus;
+import org.mifos.application.reports.ui.SelectionItem;
+import org.mifos.framework.exceptions.PersistenceException;
+import org.mifos.framework.persistence.Persistence;
+
+public class SelectionItemPersistence extends Persistence {
+	public List<SelectionItem> getActiveBranchesUnderUser(String officeSearchId)
+			throws PersistenceException {
+		Map<String, Object> queryParameters = new HashMap<String, Object>();
+		queryParameters.put("officeLevelId", OfficeLevel.BRANCHOFFICE
+				.getValue());
+		queryParameters.put("officeSearchId", officeSearchId + "%");
+		queryParameters.put("ACTIVE", OfficeStatus.ACTIVE.getValue());
+		return executeNamedQuery(GET_ACTIVE_BRANCHES_AS_SELECTION_ITEM,
+				queryParameters);
+	}
+
+	public List<SelectionItem> getActiveLoanOfficersUnderOffice(Short officeId)
+			throws PersistenceException {
+		Map<String, Object> queryParameters = new HashMap<String, Object>();
+		queryParameters.put("officeId", officeId);
+		queryParameters.put("personnelLevelId", PersonnelLevel.LOAN_OFFICER
+				.getValue());
+		queryParameters.put("ACTIVE", PersonnelStatus.ACTIVE.getValue());
+		return executeNamedQuery(
+				GET_ACTIVE_LOAN_OFFICERS_UNDER_OFFICE_AS_SELECTION_ITEM,
+				queryParameters);
+	}
+
+	public List<SelectionItem> getActiveCentersUnderUser(Short branchId,
+			Short loanOfficerId) throws PersistenceException {
+		HashMap<String, Object> queryParameters = populateCustomerQueryParams(
+				branchId, loanOfficerId, CustomerLevel.CENTER.getValue(),
+				CustomerStatus.CENTER_ACTIVE.getValue());
+		return executeNamedQuery(
+				GET_ACTIVE_CUSTOMERS_UNDER_LOAN_OFFICER_AS_SELECTION_ITEM,
+				queryParameters);
+	}
+
+	private HashMap<String, Object> populateCustomerQueryParams(Short branchId,
+			Short loanOfficerId, Short customerLevel, Short customerStatus) {
+		HashMap<String, Object> queryParameters = new HashMap<String, Object>();
+		queryParameters.put("personnelId", loanOfficerId);
+		queryParameters.put("officeId", branchId);
+		queryParameters.put("customerLevelId", customerLevel);
+		queryParameters.put("ACTIVE", customerStatus);
+		return queryParameters;
+	}
+
+	public List<SelectionItem> getActiveGroupsUnderUser(Short officeId,
+			Short personnelId) throws PersistenceException {
+		HashMap<String, Object> queryParameters = populateCustomerQueryParams(
+				officeId, personnelId, CustomerLevel.GROUP.getValue(),
+				CustomerStatus.GROUP_ACTIVE.getValue());
+		return executeNamedQuery(
+				NamedQueryConstants.GET_ACTIVE_CUSTOMERS_UNDER_LOAN_OFFICER_AS_SELECTION_ITEM,
+				queryParameters);
+	}
+}
Index: src/org/mifos/application/reports/business/DetailedAgingPortfolioReportParameters.java
===================================================================
--- src/org/mifos/application/reports/business/DetailedAgingPortfolioReportParameters.java	(revision 0)
+++ src/org/mifos/application/reports/business/DetailedAgingPortfolioReportParameters.java	(revision 0)
@@ -0,0 +1,64 @@
+package org.mifos.application.reports.business;
+
+import static org.mifos.application.reports.util.helpers.CollectionSheetReportConstants.REPORT_PARAMS_ARRAY;
+
+import javax.servlet.http.HttpServletRequest;
+
+import org.mifos.application.reports.business.validator.Errors;
+import org.mifos.framework.servlet.ModifiableParameterServletRequest;
+import org.mifos.framework.util.helpers.NumberUtils;
+import org.mifos.framework.util.helpers.ServletUtils;
+
+public class DetailedAgingPortfolioReportParameters implements ReportParameterForm{
+
+	public static final String BRANCH_ID_PARAM = "branchId";
+	public static final String LOAN_OFFICER_ID_PARAM = "loanOfficerId";
+	public static final String LOAN_PRODUCT_ID = "loanProductId";
+	
+	public static final String BRANCH_ID_INVALID_MSG = "branchId.invalid";
+	public static final String LOAN_OFFICER_ID_INVALID_MSG = "loanOfficerId.invalid";
+	public static final String LOAN_PRODUCT_ID_INVALID_MSG = "loanProductId.invalid";
+
+	private final String branchId;
+	private final String loanOfficerId;
+	private final String productId;
+
+	public static final String VALID_ID = "1";
+
+	public static final String INVALID_ID = "-2";
+
+	DetailedAgingPortfolioReportParameters(String branchId, String loanOfficerId,String productId) {
+		this.branchId = branchId;
+		this.loanOfficerId = loanOfficerId;
+		this.productId = productId;
+	}
+
+	public void validate(Errors errors) {
+	    addErrorIfInvalid(errors, branchId, BRANCH_ID_PARAM, BRANCH_ID_INVALID_MSG);	
+	    addErrorIfInvalid(errors, loanOfficerId, LOAN_OFFICER_ID_PARAM, LOAN_OFFICER_ID_INVALID_MSG);
+	    addErrorIfInvalid(errors, productId, LOAN_PRODUCT_ID, LOAN_PRODUCT_ID_INVALID_MSG);
+	}
+
+	private void addErrorIfInvalid(Errors errors, String parameter,
+			String fieldName, String errorCode) {
+		if (!NumberUtils.isDigits(parameter)
+				|| Integer.valueOf(INVALID_ID).equals(Integer.valueOf(parameter))) {
+			errors.rejectValue(fieldName, errorCode);
+		}
+	}
+
+	public static DetailedAgingPortfolioReportParameters build(HttpServletRequest request) {
+		return new DetailedAgingPortfolioReportParameters(
+				ServletUtils.getParameter(request, BRANCH_ID_PARAM),
+				ServletUtils.getParameter(request, LOAN_OFFICER_ID_PARAM),
+				ServletUtils.getParameter(request, LOAN_PRODUCT_ID)
+				);
+	}
+
+	public void removeRequestParameters(ModifiableParameterServletRequest modifiedRequest, Errors errors) {
+		for (String reportParam : REPORT_PARAMS_ARRAY) {
+			if (errors.getFieldError(reportParam) != null)
+				modifiedRequest.removeParameter(reportParam);
+		}
+	}
+}
